module approx_final_result(
    input signed [11:0] partial_product_0,
    input signed [10:0] partial_product_1, partial_product_2,
    input signed [9:0] partial_product_3,
    input [3:0] S,
    output logic signed [15:0] total
);

logic signed [15:0] pp_16[0:3];

logic signed [15:0] s_16[0:3];

always @ *
    begin
        pp_16[0] = {4'b0, partial_product_0};
        pp_16[1] = {3'b0, partial_product_1, 2'b0};
        pp_16[2] = {1'b0, partial_product_2, 4'b0};
        pp_16[3] = {partial_product_3, 6'b0};

        // Set column 0 to 0
        //s_16[0] = 16'b0; // set the S0 = 0
        
        s_16[0] = {15'b0, 1'b0};
        s_16[1] = {13'b0, 1'b0, 2'b0};
        s_16[2] = {11'b0, S[2], 4'b0};
        s_16[3] = {9'b0, S[3], 6'b0};

        pp_16[0] = pp_16[0] + s_16[0];
        pp_16[1] = pp_16[1] + s_16[1];
        pp_16[2] = pp_16[2] + s_16[2];
        pp_16[3] = pp_16[3] + s_16[3];

        total = pp_16[0] +pp_16[1] +pp_16[2] +pp_16[3];
    end

endmodule
